if Code.ensure_loaded?(NimbleCSV) do
  defmodule Clickhouse.Format.TSV do
    @moduledoc """
    An implementation of the Clickhouse `"TSV"`/`"TabSeparatedValues"` format.
    """

    @behaviour Clickhouse.Format

    alias Clickhouse.Result

    @parser __MODULE__.Parser

    NimbleCSV.define(@parser, separator: "\t", escape: "\"")

    @impl Clickhouse.Format
    @spec decode(Clickhouse.Result.t()) :: {:ok, Clickhouse.Result.t()}
    def decode(result) do
      data = @parser.parse_string(result.__raw__, skip_headers: false)
      result = Result.put_data(result, data)
      {:ok, result}
    end
  end
end
